package org.joinpointinterfaces;

import java.io.IOException;
import java.lang.ClassNotFoundException;
import javax.swing.JMenuItem;
import org.jhotdraw.contrib.CTXCommandMenu;
import org.jhotdraw.contrib.zoom.*;
import org.jhotdraw.figures.*;
import org.jhotdraw.framework.*;
import org.jhotdraw.standard.*;
import org.jhotdraw.util.*;
import org.jhotdraw.figures.*;

/**
 * joinpointinterfaces definition
 */

<R extends AbstractCommand> jpi void CommandContractsCheckingView(R acommand); 
<R extends AbstractCommand> jpi void CommandContractsNotifyingView(R acommand) extends CommandContractsCheckingView(acommand);

//CommandObserver
jpi void SetEventDispatcher(AbstractCommand acommand);
jpi void ViewSelectionChanged(AbstractCommand acommand, DrawingView oldView, DrawingView newView);
jpi void AddingMenuItemCTXCommandMenu(CTXCommandMenu menu, JMenuItem m);
jpi void AddingMenuItemCommandMenu(CommandMenu menu, Command command, JMenuItem m);

//UndoableCommand
jpi void CallCommandFigureSelectionChanged(DrawingView drawingView);
jpi void CallCommandExecute();
jpi Undoable CallCommandGetUndoActivity();

jpi void CommandExecuteInitUndo(AlignCommand ac); //AlignCommandUndo
jpi void CommandExecuteInitUndo(BringToFrontCommand ac); //BringToFrontCommandUndo
jpi void CommandExecuteInitUndo(ChangeAttributeCommand ac); //ChangeAttributeCommandUndo
jpi void CommandExecuteInitUndo(CutCommand ac); //CutCommandUndo
jpi void CommandExecuteInitUndo(DeleteCommand ac); //DeleteCommandUndo
jpi void CommandExecuteInitUndo(DuplicateCommand ac); //DuplicateCommandUndo
jpi void CommandExecuteInitUndo(GroupCommand ac); //GroupCommandUndo
jpi void CommandExecuteInitUndo(Figure figure); //GroupCommandUndo
jpi void CommandExecuteInitUndo(PasteCommand ac); //PasteCommandUndo

//DuplicateCommandUndo
jpi FigureEnumeration CommandExecuteInitUndoAffectedFigures_DuplicateCommandUndo(DuplicateCommand ac);

jpi Object ClipboardGetContents_PasteCommandUndo(PasteCommand ac);
jpi FigureEnumeration InsertFigures_PasteCommandUndo(PasteCommand ac);

//FigureSelectionSubjectRole
jpi void Initialization_FigureSelectionSubjectRole(StandardDrawingView sdv);
jpi void ReadObject_FigureSelectionSubjectRole(StandardDrawingView sdv) throws ClassNotFoundException, IOException;

//SelectionChangedNotification
jpi void InvalidateSelFigure_SelectionChangedNotification(StandardDrawingView sdw);
jpi void ClearToggleSelection_SelectionChangedNotification(StandardDrawingView sdw);


